 function [x,w,w1] = lg_rule(n);
%         [x,w] = lg_rule(n)
% This function returns the nodes and weights for a nth order
% Gauss Legendre rule for [0, 1].
% This matlab program is copyrighted @2001 by Ming-Jun Lai and Paul Wenston
% through University of Georgia Research Foundation, Inc..
     P0 = [1];
     P1 = [1 0];
     for i = 2:n
        P2 = conv([(2*i-1)/i 0],P1) - [0 0 (i-1)/i*P0];
        P0 = P1;
        P1 = P2;
     end;
     x = sort(roots(P1));
     w = 2*(1 - x.^2)./(n*polyval(P0,x)).^2;
%     n=size(x,1); n1=[n:-1:1]; p1=P1(1:n); dP1=n1.*p1;
%     w1=2./((1-x.^2).*(polyval(dP1,x).^2));

