function [M S] = msGBCvP(V,P);
%        [M S]= msGBCvP(V,P);
% This function computes the mass and stiffness matrices for 
% a partition  [V,P] of polygons.
% Author: Ming-Jun Lai
% e-mail: mjlai@math.uga.edu
% Created: Dec. 2014, using Matlab R2014b
% Copyright 2014.
[m,n]= size(P);
d=2;
M = sparse(10); S=M; L=0; M1=zeros(n,1); LocM=[]; LocS=[];
parfor k = 1:n
    p=P{k}; [i,j]=size(p); m=2*j; M1(k)=m;
 switch j
     case 3
%     if j==3
Mat =build(d);
Mat1=build(d-1); 
T=[1 0 0 0 0 0;0 1 0 0 0 0;0 0 1 0 0 0;0 0 0 0 1 0;0 0 0 0 0 1; ...
    0 0  0 1 0 0];
T2=[1 -0.5 0 0 0 -0.5;0 2 0 0 0 0;0 -0.5 1 -0.5 0 0;0 0 0 2 0 0; ...
0 0 0 -0.5 1 -0.5;0 0 0 0 0 2];
T=T2*T;
Mat=T*Mat*T';
     v1=V(p(1),:);v2=V(p(2),:);v3=V(p(3),:);
    V1=[v1;v2;v3]; 
     LocM=abs(triarea(v1,v2,v3))*Mat; 
     LocS = locStiff(v1,v2,v3,Mat1,d); LocS=T*LocS*T';
 %   if j==4
     case 4
 v1=V(p(1),:);v2=V(p(2),:);v3=V(p(3),:);
    v4=V(p(4),:); 
    V1=[v1;v2;v3;v4;]; 
   [LocM LocS] = locMassStiff(V1,5,1);
%    end
     case 5
%    if j==5
    v1=V(p(1),:);v2=V(p(2),:);v3=V(p(3),:);
    v4=V(p(4),:);v5=V(p(5),:); 
    V1=[v1;v2;v3;v4;v5]; 
   [LocM LocS] = locMassStiffp(V1,5,1);
%    end
     case 6
%    if j==6
    v1=V(p(1),:);v2=V(p(2),:);v3=V(p(3),:);
    v4=V(p(4),:); v5=V(p(5),:);v6=V(p(6),:);
    V1=[v1;v2;v3;v4;v5;v6]; 
   [LocM LocS] = locMassStiffH(V1,5,1);
        case 7
%    if j==7
    v1=V(p(1),:);v2=V(p(2),:);v3=V(p(3),:);
    v4=V(p(4),:); v5=V(p(5),:);v6=V(p(6),:); v7=V(p(7),:);
    V1=[v1;v2;v3;v4;v5;v6;v7]; 
   [LocM LocS] = locMassStiffs(V1,5,1);
    case 8
%    if j==8
    v1=V(p(1),:);v2=V(p(2),:);v3=V(p(3),:); v8=V(p(8),:);
    v4=V(p(4),:); v5=V(p(5),:);v6=V(p(6),:); v7=V(p(7),:);
    V1=[v1;v2;v3;v4;v5;v6;v7;v8]; 
   [LocM LocS] = locMassStiffo(V1,5,1);
    case 9
%    if j==9
    v1=V(p(1),:);v2=V(p(2),:);v3=V(p(3),:); v8=V(p(8),:);
    v4=V(p(4),:); v5=V(p(5),:);v6=V(p(6),:); v7=V(p(7),:); v9=V(p(9),:);
    V1=[v1;v2;v3;v4;v5;v6;v7;v8;v9]; 
   [LocM LocS] = locMassStiff9(V1,5,1);
       case 10
%    if j==10
    v1=V(p(1),:);v2=V(p(2),:);v3=V(p(3),:); v8=V(p(8),:);v10=V(p(10),:);
     v4=V(p(4),:); v5=V(p(5),:);v6=V(p(6),:); v7=V(p(7),:); v9=V(p(9),:);
    V1=[v1;v2;v3;v4;v5;v6;v7;v8;v9;v10]; 
   [LocM LocS] = locMassStiff10(V1,5,1);
 end 
    M2{k}=LocM(:); S2{k}=LocS(:);
%   M(L+1:L+m,L+1:L+m) = LocM;
%   S(L+1:L+m,L+1:L+m) = LocS;
%    L=L+m; 
end;
Mind=sum(M1(:));
M=sparse(Mind); S=M; N=0;
for k=1:n
    m=M1(k); 
    temp=M2{k}; 
    M(N+1:N+m,N+1:N+m)=reshape(temp,m,m);
    temp=S2{k};
    S(N+1:N+m,N+1:N+m)=reshape(temp,m,m);
    N=N+m;
end